package com.myoa.engineering.crawl.shopping.domain.entity.v1;

import com.myoa.engineering.crawl.shopping.domain.entity.Auditable;
import com.myoa.engineering.crawl.shopping.support.dto.constant.PpomppuBoardName;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.time.Instant;

@Getter
@NoArgsConstructor
@Entity
@Table(name = "ppomppu_article")
public class PpomppuArticle extends Auditable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column
    private Long articleId;

    @Column
    @Enumerated(EnumType.STRING)
    private PpomppuBoardName boardName;

    @Column
    private String articleUrl;

    @Column
    private String thumbnailUrl;

    @Column
    private String title;

    @Column
    private Integer hit;

    @Column
    private Integer recommended;

    @Column
    private Instant registeredAt;

    @Builder
    public PpomppuArticle(Long id, Long articleId, PpomppuBoardName boardName, String articleUrl,
                          String thumbnailUrl, String title, Integer recommended, Integer hit,
                          Instant registeredAt) {
        this.id = id;
        this.articleId = articleId;
        this.boardName = boardName;
        this.articleUrl = articleUrl;
        this.thumbnailUrl = thumbnailUrl;
        this.title = title;
        this.recommended = recommended;
        this.hit = hit;
        this.registeredAt = registeredAt;
    }

    public PpomppuArticle updateBoardName(PpomppuBoardName boardName) {
        this.boardName = boardName;
        return this;
    }
}
