package com.myoa.engineering.crawl.shopping.domain.entity.v1;

import com.myoa.engineering.crawl.shopping.domain.entity.Auditable;
import com.myoa.engineering.crawl.shopping.support.dto.constant.PpomppuBoardName;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.time.Instant;

@Getter
@NoArgsConstructor
@Entity
@Table(name = "ppomppu_board_feed_status")
public class PpomppuBoardFeedStatus extends Auditable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column
    private Long latestParsedArticleId;

    @Column
    @Enumerated(EnumType.STRING)
    private PpomppuBoardName boardName;

    @Column
    private Instant updatedAt;

    public static PpomppuBoardFeedStatus of(PpomppuBoardName boardName, Long latestArticleId) {
        return PpomppuBoardFeedStatus.builder()
                                     .boardName(boardName)
                                     .latestParsedArticleId(latestArticleId)
                                     .updatedAt(Instant.now())
                                     .build();
    }

    public void updateArticleId(Long latestArticleId) {
        this.updatedAt = Instant.now();
        this.latestParsedArticleId = latestArticleId;
    }

    @Builder
    public PpomppuBoardFeedStatus(Long id, Long latestParsedArticleId, PpomppuBoardName boardName, Instant updatedAt) {
        this.id = id;
        this.latestParsedArticleId = latestParsedArticleId;
        this.boardName = boardName;
        this.updatedAt = updatedAt;
    }
}
