package com.myoa.engineering.crawl.shopping.domain.entity.v2;

import com.myoa.engineering.crawl.shopping.domain.entity.Auditable;
import com.myoa.engineering.crawl.shopping.support.dto.constant.CrawlTarget;
import javax.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

import java.time.ZonedDateTime;

@Getter
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table
public class Article extends Auditable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column
    private Long articleId;

    @Column
    @Enumerated(EnumType.STRING)
    private CrawlTarget crawlTarget;

    @Column
    private String boardName;

    @Column
    private String articleUrl;

    @Column
    private String title;

    @Column
    private Integer hit;

    @Column
    private Integer recommended;

    @Column
    private ZonedDateTime registeredAt;

    public Article update(Article article) {
        this.boardName = article.getBoardName();
        this.articleUrl = article.getArticleUrl();
        this.title = article.getTitle();
        this.hit = article.getHit();
        this.recommended = article.getRecommended();
        return this;
    }

    public Article updateCrawlTarget(CrawlTarget crawlTarget) {
        this.crawlTarget = crawlTarget;
        return this;
    }
}
