package com.myoa.engineering.crawl.shopping.domain.model.v2;

import com.myoa.engineering.crawl.shopping.domain.entity.v2.AppUser;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;

@Getter
@Builder
@AllArgsConstructor
public class AppUserModel {

    private Long id;
    private String name;
    private String slackId;
    private Boolean enabled;

    public static AppUserModel from(AppUser entity) {
        return AppUserModel.builder()
                           .id(entity.getId())
                           .name(entity.getName())
                           .slackId(entity.getSlackId())
                           .enabled(entity.getEnabled())
                           .build();
    }
}
