package com.myoa.engineering.crawl.shopping.domain.model.v2;

import com.myoa.engineering.crawl.shopping.support.dto.constant.CrawlTarget;
import com.myoa.engineering.crawl.shopping.util.AhoCorasickUtils;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import org.ahocorasick.trie.Trie;

import java.util.List;

@Getter
@Builder
@AllArgsConstructor
public class SubscribedKeywordAggregatedModel {
    private final Trie ahoCorasickTrie;
    private final String userId;
    private final CrawlTarget crawlTarget;

    public static SubscribedKeywordAggregatedModel of(String userId, CrawlTarget crawlTarget, List<String> keywords) {
        return SubscribedKeywordAggregatedModel.builder()
                                               .userId(userId)
                                               .crawlTarget(crawlTarget)
                                               .ahoCorasickTrie(AhoCorasickUtils.generateTrie(keywords))
                                               .build();
    }
}
