package com.myoa.engineering.crawl.shopping.dto;

import com.myoa.engineering.crawl.shopping.support.dto.constant.PpomppuBoardName;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.Instant;

/**
 * FeedParsedResult
 *
 * @author Shin Woo-jin (woozu.shin@kakaoent.com)
 * @since 2021-09-08
 */
@Getter
@NoArgsConstructor
public class FeedParsedResult implements Serializable {

    private static final long serialVersionUID = -3771310078623481348L;

    private PpomppuBoardName boardName;
    private Instant requestedAt;
    private Instant processedAt;

    @Builder
    public FeedParsedResult(PpomppuBoardName boardName, Instant requestedAt, Instant processedAt) {
        this.boardName = boardName;
        this.requestedAt = requestedAt;
        this.processedAt = processedAt;
    }

    public static FeedParsedResult of(PpomppuBoardName boardName) {
        return FeedParsedResult.builder()
                               .boardName(boardName)
                               .requestedAt(Instant.now())
                               .build();
    }

    public FeedParsedResult done() {
        this.processedAt = Instant.now();
        return this;
    }

}
