package com.myoa.engineering.crawl.shopping.dto.slack;

import com.fasterxml.jackson.annotation.JsonInclude;

import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

/**
 * MessageBlock
 * @author Shin Woo-jin (woo-jin.shin@linecorp.com)
 * @since 2021-11-30
 *
 */
@Getter
@NoArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SlackBaseMessageBlock implements SlackMessageBlock {
    private static final long serialVersionUID = 1597984001727808419L;

    private SlackMessageBlockType type;
    private String text;

    @Builder
    private SlackBaseMessageBlock(SlackMessageBlockType type, String text) {
        this.type = type;
        this.text = text;
    }

    public static SlackBaseMessageBlock ofMarkDown(String message) {
        return SlackBaseMessageBlock.builder()
                                    .type(SlackMessageBlockType.MARKDOWN)
                                    .text(message)
                                    .build();
    }

    public static SlackBaseMessageBlock ofDivider() {
        return SlackBaseMessageBlock.builder()
                                    .type(SlackMessageBlockType.DIVIDER)
                                    .build();
    }

    @Override
    public String getType() {
        return type.getType();
    }
}
