package com.myoa.engineering.crawl.shopping.infra.client.slack;

import com.myoa.engineering.crawl.shopping.configuration.FeignDefaultConfig;
import com.myoa.engineering.crawl.shopping.dto.slack.SlackMessageDTO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;

@FeignClient(value = "slack-api-client", url = "https://slack.com/api",
        configuration = FeignDefaultConfig.class)
public interface SlackAPIClient {

    @PostMapping("/chat.postMessage")
    String sendMessage(@RequestBody SlackMessageDTO message,
                       @RequestHeader("Authorization") String token);
}
