package com.myoa.engineering.crawl.shopping.service;

import com.myoa.engineering.crawl.shopping.domain.model.v2.AppUserModel;
import com.myoa.engineering.crawl.shopping.infra.repository.v2.AppUserRepository;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AppUserQueryService {

    private final AppUserRepository appUserRepository;

    public AppUserQueryService(AppUserRepository appUserRepository) {
        this.appUserRepository = appUserRepository;
    }

    public List<AppUserModel> findAll() {
        return appUserRepository.findAll()
                                .stream()
                                .map(AppUserModel::from)
                                .toList();
    }

}
