package com.myoa.engineering.crawl.shopping.util;

import java.time.*;
import java.time.format.DateTimeFormatter;

public final class DateTimeUtils {

    private static final DateTimeFormatter FORMATTER_HHMMss = DateTimeFormatter.ofPattern("HH:mm:ss");
    private static final ZoneId ZONE_ASIA_SEOUL = ZoneId.of("Asia/Seoul");

    private DateTimeUtils() {
    }

    public static ZonedDateTime parse(String HHMMss) {
        try {
            LocalTime time = LocalTime.parse(HHMMss, FORMATTER_HHMMss);
            LocalDateTime dateTime = LocalDateTime.of(LocalDate.now(), time);
            if (dateTime.isAfter(LocalDateTime.now())) {
                dateTime = dateTime.minusDays(1);
            }
            return dateTime.atZone(ZONE_ASIA_SEOUL);
        } catch (Exception e) {
            return null;
        }
    }

}
