package com.myoa.engineering.crawl.shopping.util;

public final class NumberUtils {

    private NumberUtils() {
    }

    public static Integer parseInt(String value) {
        return parseInt(value, null);
    }

    public static Integer parseInt(String value, Integer defaultValue) {
        try {
            return Integer.parseInt(value);
        } catch (NumberFormatException e) {
            return defaultValue;
        }
    }

    public static Long parseLong(String value) {
        return parseLong(value, null);
    }

    public static Long parseLong(String value, Long defaultValue) {
        try {
            return Long.parseLong(value);
        } catch (NumberFormatException e) {
            return defaultValue;
        }
    }

}
