 package com.myoa.engineering.crawl.shopping.support.dto;

import java.io.Serializable;
import java.time.Instant;

import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

/**
 * SimpleMessageDTO
 * @author Shin Woo-jin (woo-jin.shin@linecorp.com)
 * @since 2021-11-21
 *
 */
@Getter
@NoArgsConstructor
public class SimpleMessageDTO implements Serializable {

    private static final long serialVersionUID = 2203955567672404428L;

    private String title;
    private String body;
    private String url;
    private Instant publishedAt;
    private Instant requestedAt;

    @Builder
    public SimpleMessageDTO(String title, String body, String url, Instant publishedAt, Instant requestedAt) {
        this.title = title;
        this.body = body;
        this.url = url;
        this.publishedAt = publishedAt;
        this.requestedAt = requestedAt;
    }

}
