package com.myoa.engineering.crawl.shopping.support.dto.constant;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;

/**
 * PpomppuBoardName
 *
 * @author Shin Woo-jin (woo-jin.shin@linecorp.com)
 * @since 2021-09-05
 */
@Getter
@AllArgsConstructor
public enum PpomppuBoardName {
    UNKNOWN("", "UNKNOWN", false, false),
    PPOMPPU_DOMESTIC_ALL("id=ppomppu", "전체", false, true),
    PPOMPPU_DOMESTIC_ETC("id=ppomppu&category=1", "기타", true, true),
    PPOMPPU_DOMESTIC_COMPUTER("id=ppomppu&category=4", "컴퓨터", true, true),
    PPOMPPU_DOMESTIC_DIGITAL("id=ppomppu&category=5", "디지털", true, true),
    PPOMPPU_DOMESTIC_FOOD("id=ppomppu&category=6", "식품/건강", true, true),
    PPOMPPU_DOMESTIC_BOOK("id=ppomppu&category=8", "서적", true, true),
    PPOMPPU_DOMESTIC_APPLIANCES("id=ppomppu&category=9", "가전/가구", true, true),
    PPOMPPU_DOMESTIC_PARENTING("id=ppomppu&category=10", "육아", true, true),
    PPOMPPU_DOMESTIC_GIFTCARD("id=ppomppu&category=11", "상품권", true, true),
    PPOMPPU_DOMESTIC_CLOTHES("id=ppomppu&category=12", "의류/잡화", true, true),
    PPOMPPU_DOMESTIC_COSMETIC("id=ppomppu&category=13", "화장품", true, true),
    PPOMPPU_DOMESTIC_OUTDOOR("id=ppomppu&category=15", "등산/캠핑", true, true),
    PPOMPPU_OVERSEA_ALL("id=ppomppu4", "전체", false, false),
    PPOMPPU_OVERSEA_ETC("id=ppomppu4&category=1", "기타", true, false),
    PPOMPPU_OVERSEA_APPLIANCES("id=ppomppu4&category=7", "가전", true, false),
    PPOMPPU_OVERSEA_TVAV("id=ppomppu4&category=8", "TV/영상", true, false),
    PPOMPPU_OVERSEA_COMPUTER("id=ppomppu4&category=3", "컴퓨터", true, false),
    PPOMPPU_OVERSEA_DIGITAL("id=ppomppu4&category=4", "디지털", true, false),
    PPOMPPU_OVERSEA_MOBILEACCESSORY("id=ppomppu4&category=9", "액세서리", false, true),
    PPOMPPU_OVERSEA_CLOTHES("id=ppomppu4&category=5", "의류/잡화", true, false),
    PPOMPPU_OVERSEA_WATCH("id=ppomppu4&category=2", "시계", true, false),
    PPOMPPU_OVERSEA_SHOES("id=ppomppu4&category=11", "신발", true, false),
    PPOMPPU_OVERSEA_FOOD("id=ppomppu4&category=10", "식품/건강", true, false),
    PPOMPPU_OVERSEA_PARENTING("id=ppomppu4&category=6", "육아", true, false),
    ;

    private String resourcePath;
    private String menuName;
    private boolean crawlWithDefaultTimer;
    private boolean isDomestic;

    public static final String PPOMPPU_URL = "https://www.ppomppu.co.kr";

    public static String ofViewPageUrl(String articleUrl) {
        return PPOMPPU_URL + "/zboard/" + articleUrl;
    }

    public static PpomppuBoardName ofBoardName(String boardName, boolean isDomestic) {
        return Arrays.stream(values())
                     .filter(e -> e.getMenuName().equals(boardName) && e.isDomestic() == isDomestic)
                     .findFirst()
                     .orElse(UNKNOWN);
    }

}
