package com.myoa.engineering.crawl.shopping.support.webclient.properties;

import java.util.ArrayList;
import java.util.List;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.lang.NonNull;
import org.springframework.stereotype.Component;

import lombok.Data;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

/**
 * WebClientPropertiesUnit
 * @author Shin Woo-jin (woo-jin.shin@linecorp.com)
 * @since 2021-11-18
 *
 */
@NoArgsConstructor
@Setter
@Getter
@Component
@ConfigurationProperties(prefix = "webclient")
public class WebClientProperties {

    private List<WebClientPropertiesUnit> units = new ArrayList<>();

    @Data
    public static class WebClientPropertiesUnit {
        private String unitName;
        private String baseUrl;
        // TODO headers
    }

    public WebClientPropertiesUnit find(@NonNull String unitName) {
        return units.stream()
                    .filter(x -> x.getUnitName().equals(unitName))
                    .findFirst()
                    .orElseThrow(
                        () -> new IllegalArgumentException("Not found properties unit. unitName : " + unitName));
    }
}
